/*************************************************************************************
Assignment 3 in course MAT259 
3D visualization - Social Dilemma & User Behaviors - Qing Huang

Green: Negative
Red: Positive

Borrowed from Data Visualization - Basic 3D Demo                                                                     
Author: Rodger (Jieliang) Luo                        
Supervisor: George Legradsy             

Borrowed from Data Visualization - PROJECT2                                                                     
Author: Yanchen Lu                        
Supervisor: George Legradsy    

Purpose: Show how to present volume data in a basic 3D environment     

Usage: 1. A mouse left-drag will rotate the camera around the subject.
          2. A right drag will zoom in and out. 
          3. A double-click restores the camera to its original position. 
          4. rotation

*************************************************************************************/
import controlP5.*;
import peasy.*;
PeasyCam cam;
ControlP5 cp5;


int numMiddlePoints = 5;
color c3 = color(51, 0, 102);
color c1 = color(209, 204, 255); 

color c7 = color(0, 102, 204);
color c5 = color(153, 204, 255); 

color c8 = color(102, 0, 51);
color c9 = color(255, 102, 178);

color lin = color(255, 255, 255);

float gray;
float fillColor;
boolean showBox;
boolean showX;
boolean showY;
boolean showZ;
boolean SHOWRED = true;
boolean SHOWGREEN = true;
boolean SHOWNEUTRAL = true;
boolean showDate = false;
boolean showItem = false;
String s;
String y;
float n;

int startYear = 2006;
int endYear = 2022;

Table table;
int numRows, numColumns;

ArrayList<User> users = new ArrayList<User>();

void setup(){
  size(1000, 1000, P3D);
  cam = new PeasyCam(this, 300);
  
  //Added on Jan 30th by Rodger Luo
  float  cameraZ = (height/2.0) / tan(PI*60.0/360.0);
  perspective(PI/3.0, width/height, 0.001, cameraZ*10.0); //set near clip to 0.001 to go inside data
  //Finished adding 
  
  table = loadTable("data-SD.csv", "header");
  numRows = table.getRowCount();
  println("Rows: " + numRows);
  
  for(int i=0; i<numRows; i++){
    int ID = table.getInt(i,0);
    String date= table.getString(i,1);  
    String time= table.getString(i,2);
    float  botscore= table.getFloat(i,3);
    int m1=table.getInt(i,4);
    int m2=table.getInt(i,5);
    int sentiment=table.getInt(i,6);    
    String topic=table.getString(i,7);
    users.add(new User(ID, date, time, botscore, m1, m2, sentiment,topic));
  }
  cp5 =new ControlP5(this);
  gray=128;
  showBox = true;
  showX = true;
  showY = true;
  showZ = true;

  fillColor= 255;
  setGui();
}


void draw(){
  background(0);
  
  for(int i=0; i<users.size(); i++){
    float dateAxis = map(dateParser(users.get(i).date)-30, -30, 60, -100, 100);
    float date2Axis = map(dateParser(users.get(i).date)+30, -30, 60, -100, 100);
    float timeAxis = map(timeParser(users.get(i).time), 0, 1440, -50, 50);
    float m1Axis = map(users.get(i).m1, 3000, 0, -50, 50);
    float m2Axis =  map(users.get(i).m2, 3000, 0, -50, 50);
    color c = sentimentDetermine(users.get(i).sentiment);
    
    if (SHOWRED == true){
    if(users.get(i).sentiment==1){
    pushMatrix();
    translate(dateAxis, m1Axis, timeAxis);
    strokeWeight(2);
    stroke(c);
    point(0,0,0);
    point(date2Axis-dateAxis, m2Axis-m1Axis, 0);
    
    
    beginShape(LINES);
    vertex(0,0,0);
    vertex(date2Axis-dateAxis, m2Axis-m1Axis, 0);
    endShape();
  
    float mouseObjectDistance = sq(mouseX-screenX(0,0,0))+sq(mouseY-screenY(0,0,0));
    if(mouseObjectDistance < 10){
      strokeWeight(10);
      point(0,0,0);
      fill(255,255,255);
      
      float[] rotations = cam.getRotations();
      rotateX(rotations[0]);
      rotateY(rotations[1]);
      rotateZ(rotations[2]);
      
      textMode(SHAPE);
      textSize(3);
      s = users.get(i).topic.toUpperCase();
      y = users.get(i).date.toUpperCase();
      if (showDate == false){
        if (showItem == false){
          text(s,0,0);
        }else{
          text (n,0,0);
        }
      } else{
      text(y,0,0);
      }
    }
    popMatrix();
    }
    }
    
    if (SHOWGREEN == true) {
    if(users.get(i).sentiment==-1){
    pushMatrix();
    translate(dateAxis, m1Axis, timeAxis);
    strokeWeight(2);
    stroke(c);
    point(0,0,0);
    
    beginShape(LINES);
    vertex(0,0,0);
    vertex(date2Axis-dateAxis, m2Axis-m1Axis, 0);
    endShape();
    
    float mouseObjectDistance = sq(mouseX-screenX(0,0,0))+sq(mouseY-screenY(0,0,0));
    if(mouseObjectDistance < 10){
      strokeWeight(10);
      point(0,0,0);
      fill(255,255,255);
      float[] rotations = cam.getRotations();
      rotateX(rotations[0]);
      rotateY(rotations[1]);
      rotateZ(rotations[2]);
      textMode(SHAPE);
      textSize(3);
      s = users.get(i).topic.toUpperCase();
      y = users.get(i).date.toUpperCase();
      n = users.get(i).m1;
      if (showDate == false){
        if (showItem == false){
          text(s,0,0);
        }else{
          text (n,0,0);
        }
      } else{
      text(y,0,0);
            }
        }
    popMatrix();
  }
    }
    
    if (SHOWNEUTRAL == true){
    if(users.get(i).sentiment==0){
    pushMatrix();
    translate(dateAxis, m1Axis, timeAxis);
    strokeWeight(2);
    stroke(c);
    point(0,0,0);
    point(date2Axis-dateAxis, m2Axis-m1Axis, 0);
    
    
    beginShape(LINES);
    vertex(0,0,0);
    vertex(date2Axis-dateAxis, m2Axis-m1Axis, 0);
    endShape();
  
    float mouseObjectDistance = sq(mouseX-screenX(0,0,0))+sq(mouseY-screenY(0,0,0));
    if(mouseObjectDistance < 10){
      strokeWeight(10);
      point(0,0,0);
      fill(255,255,255);
      
      float[] rotations = cam.getRotations();
      rotateX(rotations[0]);
      rotateY(rotations[1]);
      rotateZ(rotations[2]);
      
      textMode(SHAPE);
      textSize(3);
      s = users.get(i).topic.toUpperCase();
      y = users.get(i).date.toUpperCase();
      if (showDate == false){
        if (showItem == false){
          text(s,0,0);
        }else{
          text (n,0,0);
        }
      } else{
      text(y,0,0);
      }
    }
    popMatrix();
    }
    }
    
  }
  
  drawLabels();  
  fill(200, 20);
  noStroke();

  
  if(showBox == true){
    box(200, 100, 100);
  }
  
  if(showX == true){
    beginShape(LINES);
  vertex(-100,50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c1, c3, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100+i*50,50,50);
  vertex(-100+i*50,50,50);
}
  vertex(100,50,50);
  endShape();
  
  beginShape(LINES);
  vertex(-100,50,-50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c1, c3, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100+i*50,50,-50);
  vertex(-100+i*50,50,-50);
}
  vertex(100,50,-50);
  endShape();
  
    beginShape(LINES);
  vertex(-100,-50,-50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c1, c3, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100+i*50,-50,-50);
  vertex(-100+i*50,-50,-50);
}
  vertex(100,-50,-50);
  endShape();
  
  beginShape(LINES);
  vertex(-100,-50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c1, c3, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100+i*50,-50,50);
  vertex(-100+i*50,-50,50);
}
  vertex(100,-50,50);
  endShape();
    
  }
  
  if(showY == true){
    beginShape(LINES);
  vertex(-100,-50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c5, c7, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100,-50+i*10,50);
  vertex(-100,-50+i*10,50);
}
  vertex(-100,50,50);
  endShape();

  beginShape(LINES);
  vertex(100,-50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c5, c7, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(100,-50+i*10,50);
  vertex(100,-50+i*10,50);
}
  vertex(100,50,50);
  endShape();
  
    beginShape(LINES);
  vertex(100,-50,-50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c5, c7, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(100,-50+i*10,-50);
  vertex(100,-50+i*10,-50);
}
  vertex(100,50,-50);
  endShape();
  
    beginShape(LINES);
  vertex(-100,-50,-50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c5, c7, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100,-50+i*10,-50);
  vertex(-100,-50+i*10,-50);
}
  vertex(-100,50,-50);
  endShape();
    
  }


  if(showZ == true){
    beginShape(LINES);
  vertex(-100,50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c8, c9, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100,50,50-i*10);
  vertex(-100,50,50-i*10);
}
  vertex(-100,50,-50);
  endShape();
  
      beginShape(LINES);
  vertex(-100,-50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c8, c9, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(-100,-50,50-i*10);
  vertex(-100,-50,50-i*10);
}
  vertex(-100,-50,-50);
  endShape();
  
      beginShape(LINES);
  vertex(100,50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c8, c9, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(100,50,50-i*10);
  vertex(100,50,50-i*10);
}
  vertex(100,50,-50);
  endShape();
  
      beginShape(LINES);
  vertex(100,-50,50);

  for (int i = 0; i< numMiddlePoints; i++) {
  color middleColor;
  middleColor = lerpColor(c8, c9, i/float(numMiddlePoints));
  stroke(middleColor);
  vertex(100,-50,50-i*10);
  vertex(100,-50,50-i*10);
}
  vertex(100,-50,-50);
  endShape();
    
  }
  
  gui();
  println(mouseX,mouseY);
  if((mouseX<180)&(mouseY<180)){
  cam.setActive(false);
  }
  else{
  cam.setActive(true);
  }
}



void drawLabels(){
  
  fill(255);
  textSize(30);
  pushMatrix();
  textAlign(LEFT, TOP);
  translate(-100, 50, 50);
  scale(0.1);
  text("Aug-10-2020", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, TOP);
  translate(100, 50, 50);
  scale(0.1);
  text("Nov-8-2020", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, TOP);
  translate(-100, -50, 50);
  scale(0.1);
  text("10AM", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(RIGHT, BOTTOM);
  translate(-100, 50, 50);
  scale(0.1);
  text("8PM", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(LEFT, CENTER);
  translate(100, 50, 50);
  scale(0.1);
  text("new", 0, 0, 0);
  popMatrix();
  
  pushMatrix();
  textAlign(LEFT, CENTER);
  translate(100, 50, -50);
  scale(0.1);
  text("old", 0, 0, 0);
  popMatrix();
}

void setGui(){
  PFont pfont=createFont("Arial", 16, true);
  ControlFont font = new ControlFont(pfont,12);
  float X = 60;
  float distance = 800;
  int index = 0;
  

  cp5.addToggle("SHOWGREEN")
  .setCaptionLabel("")
  .setFont(font)
  .setColorActive(#00BC56)
  .setColorBackground(#808080) 
  .setColorCaptionLabel(#00BC56)
  .setColorForeground(#808080) 
  .setPosition (X+400, 100);
  
    cp5.addToggle("SHOWRED")
  .setCaptionLabel("")
  .setFont(font)
  .setColorActive(#F75F00)
  .setColorBackground(#808080) 
  .setColorCaptionLabel(#F75F00)
  .setColorForeground(#808080) 
  .setPosition (X+438, 100);
  
      cp5.addToggle("SHOWNEUTRAL")
  .setCaptionLabel("")
  .setFont(font)
  .setColorActive(#b57935)
  .setColorBackground(#808080) 
  .setColorCaptionLabel(#F75F00)
  .setColorForeground(#808080) 
  .setPosition (X+476, 100);
  
    cp5.addTextlabel("labelgreen")
  .setFont(font)
  .setText("Green: Artificial Intelligence users")
  .setColor(#00BC56)
  .setPosition(X+100, 100);
  
    cp5.addTextlabel("labelred")
  .setFont(font)
  .setColor(#F75F00)
  .setText("Red: Social Media users")
  .setPosition(X+600, 100);
  
  cp5.addTextlabel("label")
  .setFont(font)
  .setText("Press Space: Show Box")
  .setPosition(X, distance);
  
   cp5.addTextlabel("label2")
  .setFont(font)
  .setText("Double Click: Original Position")
  .setPosition(X, distance+20);
  
     cp5.addTextlabel("label3")
  .setFont(font)
  .setText("Press X/Y/Z: Control X/Y/Z")
  .setPosition(X, distance+40);

     cp5.addTextlabel("label4")
  .setFont(font)
  .setText("Mouse Near Point: Show Book topic")
  .setPosition(X, distance+60);
  
  
     cp5.addTextlabel("label5")
  .setFont(font)
  .setText("Press SHIFT: Show Check-out Date Instead")
  .setPosition(X, distance+80);
  
       cp5.addTextlabel("label6")
  .setFont(font)
  .setText("Press CONTROL: Show m1ber Instead")
  .setPosition(X, distance+100);
  
     cp5.addBang("zoomIn")
  .setLabel("Zoom In")
  .setColorActive(color(#E6A05E))
  .setColorForeground(color(#66472A))
  .setPosition(X, 140);
  
  cp5.addBang("zoomOut")
  .setLabel("Zoom Out")
  .setColorActive(color(#E6A05E))
  .setColorForeground(color(#66472A))
  .setPosition(X + 50, 140);


  cp5.addTextlabel("rotate Y")
  .setText("Rotate along the y-axis")
  .setPosition(X, 200);
  
  cp5.addBang("rotY")
  .setLabel("CW")
  .setPosition(X, 220);

  cp5.addBang("rotYneg")
  .setLabel("CCW")
  .setPosition(X + 50, 220);


  cp5.addTextlabel("rotate X")
  .setText("Rotate along the x-axis")
  .setPosition(X, 260);
  
  cp5.addBang("rotXneg")
  .setLabel("CW")
  .setPosition(X, 280);

  cp5.addBang("rotX")
  .setLabel("CCW")
  .setPosition(X + 50, 280);
  
  
  cp5.setAutoDraw(false);
}

void randomizeColor(){
  gray = random(0,255);
}

void gui(){
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  cp5.draw();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}
